//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// This EA uses MapPath file ("rl.txt" by default) from your 
// /tester/files/ (for strategy tester) or /experts/files/ (for actual use)
// to get the initial statistics. It also continues to gather its own 
// statistics and appends it to the initial file, saving it after
// deinitilizing.
//

#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

//
//
//
//
//

extern bool   EcnBroker        = true;
extern string SymbolsPrefix    = "";
extern string SymbolsSuffix    = "";
extern bool   UseAutoMagic     = true;
extern int    ManualMagic      = 7770100;  
extern bool   EachTickMode     = true;
extern double Lots             = 0.01;
extern int    Slippage         = 3;
extern bool   StopLossMode     = true;
extern int    StopLoss         = 20;
extern bool   TakeProfitMode   = true;
extern int    TakeProfit       = 50;
extern bool   TrailingStopMode = true;
extern int    TrailingStop     = 10;
extern double MaximumRisk      = 0.001;
extern double DecreaseFactor   = 3;
extern int    MaxOrders        = 3;


extern int    MinPips          = 23;          //Min amounts of pips of profit to consider teaching BUY and SELL maps
extern int    MaxPips          = 43;          //Max amounts of pips of profit to consider teaching BUY and SELL maps
extern string MapPath          = "rl.txt";

extern string comments         = "Comments on true or false"; 
extern bool   CommentsOn       = true;   

extern string _time            = "Time Filter";
extern int    StartHour        = 0;          // Start Hour of Trade Session 
extern int    StartMinute      = 0;          // Start Minute of Trade Session 
extern int    EndHour          = 23;         // End Hour of Trade Session
extern int    EndMinute        = 0;          // End Hour of Trade Session

//
//
//
//
//

#define SELL_MAP 0
#define BUY_MAP  1
#define HOLD_MAP 2
#define SIGNAL_NONE 0
#define SIGNAL_BUY  1
#define SIGNAL_SELL 2
#define SIGNAL_CLOSEBUY  3
#define SIGNAL_CLOSESELL 4
#define VBASE 7
#define MAPBASE  10000
#define HOLDBASE 25000


//
//
//
//
//

int    BarCount;
int    Current;
int    digit = 0;
int    ortype;
int    MagicNumber;

bool   TickCheck = false;

string s_symbol;
string timeFilterText="";

double PointRatio = 1;
double _Point;
double bmu[3] = { 0,0,0     };
double hi[5]  = { 0,0,0,0,0 };   //Calculating the Tom Demark's pivot points over last 5 bars
double lo[5]  = { 0,0,0,0,0 };
double MapHold[HOLDBASE][VBASE];
double MapBuy[MAPBASE][VBASE];
double MapSell[MAPBASE][VBASE];
double vector[VBASE];            //Vector with memory-cells for current bar
double vectorp[VBASE];           //Vector with memory-cells for previous bar



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{
   BarCount = Bars;
   
   if (EachTickMode) Current = 0; 
                else Current = 1;
                
   s_symbol = Symbol();
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic; 
   
   InitKohonenMap();
   LoadKohonenMap();           
              
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() 
{ 
    SaveKohonenMap();
    Comment(" ");

return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start() 
{
   if (!IsDllsAllowed()) 
   {
     Alert("DLLs are disabled.  To enable  check the box in the tools/options/expert advisors on your chart");
     return;
   }
   
   //
   //
   //
   //
   //
   
   if (CommentsOn) ShowComments();
   
   //
   //
   //
   //
   //
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
   _Point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
   
   //
   //
   //
   //
   //
   
   if (EachTickMode && Bars != BarCount) EachTickMode = false;
   int Total = OrdersTotal();
   int Order = SIGNAL_NONE;
   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+
   //
   //

   hi[0] = High[Current+2];
   hi[1] = High[Current+3];
   hi[2] = High[Current+4];
   hi[3] = High[Current+5];
   hi[4] = High[Current+6];

   lo[0] = Low[Current+2];
   lo[1] = Low[Current+3];
   lo[2] = Low[Current+4];
   lo[3] = Low[Current+5];
   lo[4] = Low[Current+6];

   double H = hi[ArrayMaximum(hi)];
   double L = lo[ArrayMinimum(lo)];
   
   vectorp[0] = (H + L + Close[Current+2]) / 3;  //The difference between pivots and Open price is used to normalize statistics
   vectorp[1] = (2 * vectorp[0] - L)       - Open[Current+1];
   vectorp[2] = (vectorp[0] + H - L)       - Open[Current+1];
   vectorp[3] = (H + 2 * (vectorp[0] - L)) - Open[Current+1];
   vectorp[4] = (2 * vectorp[0] - H)       - Open[Current+1];
   vectorp[5] = (vectorp[0] - H + L)       - Open[Current+1];
   vectorp[6] = (L - 2 * (H - vectorp[0])) - Open[Current+1];
   vectorp[0] = vectorp[0]                 - Open[Current+1];

   hi[0] = High[Current+1];
   hi[1] = High[Current+2];
   hi[2] = High[Current+3];
   hi[3] = High[Current+4];
   hi[4] = High[Current+5];

   lo[0] = Low[Current+1];
   lo[1] = Low[Current+2];
   lo[2] = Low[Current+3];
   lo[3] = Low[Current+4];
   lo[4] = Low[Current+5];

   H = hi[ArrayMaximum(hi)];
   L = lo[ArrayMinimum(lo)];

   vector[0] = (H + L + Close[Current+1]) / 3;
   vector[1] = (2 * vector[0] - L)       - Open[Current];
   vector[2] = (vector[0] + H - L)       - Open[Current];
   vector[3] = (H + 2 * (vector[0] - L)) - Open[Current];
   vector[4] = (2 * vector[0] - H)       - Open[Current];
   vector[5] = (vector[0] - H + L)       - Open[Current];
   vector[6] = (L - 2 * (H - vector[0])) - Open[Current];
   vector[0] = vector[0]                 - Open[Current];
   
   MapLookup(vector,bmu);
   
   //
   //
   //
   //
   //
   
      if ((bmu[0] < bmu[1]) && (bmu[0] < bmu[2]) && TimeCondition()) Order = SIGNAL_BUY;
      if ((bmu[1] < bmu[0]) && (bmu[1] < bmu[2]) && TimeCondition()) Order = SIGNAL_SELL;
      
           if ((NormalizeDouble((Open[Current] - Open[Current+1]), digit) >= NormalizeDouble((MinPips*_Point), digit)) && 
               (NormalizeDouble((Open[Current] - Open[Current+1]), digit) <= NormalizeDouble((MaxPips*_Point),digit)))      TeachMap(BUY_MAP, vectorp);
      else if ((NormalizeDouble((Open[Current] - Open[Current+1]), digit) <= -NormalizeDouble((MinPips*_Point), digit)) && 
               (NormalizeDouble((Open[Current] - Open[Current+1]), digit) >= -NormalizeDouble((MaxPips*_Point),digit)))     TeachMap(SELL_MAP, vectorp);
                                                                                                                       else TeachMap(HOLD_MAP, vectorp);
      

   //+------------------------------------------------------------------+
   //|                                                                  |
   //+------------------------------------------------------------------+
   //
   //Buy
   
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
     if (ScanTrades() < MaxOrders) 
     {
     
     //
     //
     //
     //
     //
     
       if (AccountFreeMargin() < (100 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
       
       //
       //
       //
       //
       //
       
       double BStopLossLevel   = Ask - StopLoss   * _Point;
       double BTakeProfitLevel = Ask + TakeProfit * _Point;
       
       //
       //
       //
       //
       //
       
       if (!EcnBroker) 
       OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*_Point,NormalizeDouble(BStopLossLevel,digit),  
                                    NormalizeDouble(BTakeProfitLevel,digit),"Buy(#" + MagicNumber + ")",MagicNumber,0,DodgerBlue);
       else
       {
       int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*_Point,0,0,"Buy(#" + MagicNumber + ")", MagicNumber,0,Blue);
       if  (buyTicket  >= 0)
       bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BStopLossLevel,digit),NormalizeDouble(BTakeProfitLevel,digit),0,CLR_NONE);
    
       if (OrderSelect(buyTicket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); else Print("Error opening BUY order : ", GetLastError());
       }
       
       if (EachTickMode)  TickCheck = True;
       if (!EachTickMode) BarCount  = Bars;
       
       return(0);
      }
   }

   //Sell
   //
   //
   //
   //
   
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
      if (ScanTrades() < MaxOrders) 
      {
      
      //
      //
      //
      //
      //
         
         if (AccountFreeMargin() < (1000 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
         
         //
         //
         //
         //
         //
         
         double SStopLossLevel   = Bid + StopLoss   * _Point;
         double STakeProfitLevel = Bid - TakeProfit * _Point;
         
         //
         //
         //
         //
         //
         
         if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*_Point,NormalizeDouble(SStopLossLevel,digit),  
                   NormalizeDouble(STakeProfitLevel,digit),"Sell(#" + MagicNumber + ")",MagicNumber,0,DeepPink);
         
         
         else
         {
		   int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*_Point,0,0,"Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(sellTicket    >= 0) 
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SStopLossLevel,digit),NormalizeDouble(STakeProfitLevel,digit),0,CLR_NONE);
         if (OrderSelect(sellTicket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice()); 
         else Print("Error opening SELL order : ", GetLastError());
         }
         
         if (EachTickMode)  TickCheck = True;
         if (!EachTickMode) BarCount  = Bars;
         return(0);
      }
   }

   //
   //
   //
   //
   //
   
   for (int i = 0; i < Total; i ++) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol()    == s_symbol) 
      {
        if (OrderType() == OP_BUY && OrderMagicNumber()== MagicNumber) 
        {
         
            //
            //
            //
            //
            //
            
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
            {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage*_Point, MediumSeaGreen);
               if (EachTickMode)  TickCheck = True;
               if (!EachTickMode) BarCount  = Bars;
               return(0);
            }
            
            //
            //
            //
            //
            //
            
            if(TrailingStopMode && TrailingStop > 0) 
            {                 
               if(Bid - OrderOpenPrice() > _Point * TrailingStop) 
               {
                  if(OrderStopLoss() < Bid - _Point * TrailingStop) 
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - _Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                    }
                 }
              }
            }  
            else 
            {
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)
            {
           
            //
            //
            //
            //
            //
            
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
            {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage*_Point, DarkOrange);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
            }
               
            //
            //
            //
            //
            //
            
            if (TrailingStopMode && TrailingStop > 0) 
            {                 
               if((OrderOpenPrice() - Ask) > (_Point * TrailingStop))
               {
                  if((OrderStopLoss() > (Ask + _Point * TrailingStop)) || (OrderStopLoss() == 0)) 
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + _Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
         }
       }
     }
   }

   if (!EachTickMode) BarCount = Bars;
   
   return(0);
}

//
//
//
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == s_symbol && OrderType() <= OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
return(numords);
}  

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
      
   if(losses > 1) lot = NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0) * lot_step;
   if(lot < lot_min) lot = lot_min;
   if(lot > lot_max) lot = lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(7777921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(7777922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(7777931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(7777932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(7777941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(7777942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(7777951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(7777961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(7777962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(7777963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(7777964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(7777965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(7777966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(7777967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(7777971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(7777972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(7777973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(7777981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(7777982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(7777983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(7777991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(7777992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(7777993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(7777994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(7777995);
   
return(ManualMagic);
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   {
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
   { timeFilterText = "Trading Hours!"; }
   
   }    
   else
   {
   
   if (StartHour > EndHour)
   {
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   { timeFilterText = "Non-Trading Hours!"; }
   
   }
 }
return(result);
}

//
//
//
//
//

void InitKohonenMap()
{
   for (int i = 0; i < MAPBASE; i++)
   {
      for (int v = 0; i < VBASE; i++)
      {
         MapSell[i][v] = 0;
         MapBuy[i][v] = 0;
      }
   }
   for (i = 0; i < HOLDBASE; i++)
   {
      for (v = 0; i < VBASE; i++)
      {
         MapHold[i][v] = 0;
      }
   }
}

//
//
//
//
//

void MapLookup(double vector[], double& BMU[])
{
   BMU[Current]   = FindBMU(BUY_MAP,  vector);
	BMU[Current+1] = FindBMU(SELL_MAP, vector);
	BMU[Current+2] = FindBMU(HOLD_MAP, vector);
	
	int i = 0;

	//BUY
	//
	//
	//
	//
	
	for (i = 0; i < MAPBASE; i++)
	{
      int z  = 0;
      double vec[VBASE];
      for (int v = 0; v < VBASE; v++)
	   {
	     if (MapBuy[i][v] == 0) z++;
	     vec[v] = MapBuy[i][v];
	   }
	   if (z == VBASE) break;
	  
	   double E = EuclidDistance(vec, vector);
	}

	//SELL
	//
	//
	//
	//
	
	for (i = 0; i < MAPBASE; i++)
	{
      z  = 0;
      for (v = 0; v < VBASE; v++)
	   {
	     if (MapSell[i][v] == 0) z++;
	     vec[v] = MapSell[i][v];
	   }
	   if (z == VBASE) break;
	  
	   E = EuclidDistance(vec, vector);
	}

	//HOLD
	//
	//
	//
	//
	
	for (i = 0; i < HOLDBASE; i++)
	{
      z  = 0;
      for (v = 0; v < VBASE; v++)
	   {
	     if (MapHold[i][v] == 0) z++;
	     vec[v] = MapHold[i][v];
	   }
	   if (z == VBASE) break;
	  
	   E = EuclidDistance(vec, vector);
	}
}

//
//
//
//
//

double FindBMU(int Buy, double vector[])
{
	int N = 0;

	if (Buy == 1) N = MAPBASE;
	else if (Buy == 0) N = MAPBASE;
	else N = HOLDBASE;

	double BestEuclidDistance = 9999999;
	double vec[VBASE];
	for (int i = 0; i < N; i++)
	{
		double E;
      for (int v = 0; v < VBASE; v++)
	   {
	     if (Buy == 1) vec[v] = MapBuy[i][v];
	     else if (Buy == 0) vec[v] = MapSell[i][v];
	     else vec[v] = MapHold[i][v];
		}
		E = EuclidDistance(vec, vector);
		if (E < BestEuclidDistance)
		{
			BestEuclidDistance = E;
		}
	}

	return(BestEuclidDistance);
}

//
//
//
//
//

double EuclidDistance(double VectorFromMap[], double vector[])
{
	double E = 0;
	
	for (int v = 0; v < VBASE; v++)
	{
		E += MathPow((VectorFromMap[v]*10000 - vector[v]*10000), 2);
	}

	E = MathSqrt(E);

	return(E);
}

//
//
//
//
//

void TeachMap(int Buy, double vector[])
{
	int BMUx = -1;
	int N;
	int x;

	     if (Buy == 1) N = MAPBASE;
	else if (Buy == 0) N = MAPBASE;
	else               N = HOLDBASE;

	for (x = 0; x < N; x++)
	{
		bool flag = false;
		for (int v = 0; v < VBASE; v++)
		{
			if (Buy == 1) {if (MapBuy[x][v] != 0) flag = true;}
			else if (Buy == 0) {if (MapSell[x][v] != 0) flag = true;}
			else {if (MapHold[x][v] != 0) flag = true;}
		}
		if (flag == false) break;
	}

	for (v = 0; v < VBASE; v++)
	{
		if (Buy == 1) MapBuy[x][v] = vector[v];
		else if (Buy == 0) MapSell[x][v] = vector[v];
		else MapHold[x][v] = vector[v];
	}

}

//
//
//
//
//

void LoadKohonenMap()
{
   int handle = FileOpen(MapPath, FILE_BIN|FILE_WRITE|FILE_READ);
   if (handle < 1)
   {
      Print("File couldn't be opened; the last error is ", GetLastError());
      return(0);
   }
   FileReadArray(handle, MapBuy,  0, MAPBASE*VBASE);
   FileReadArray(handle, MapSell, 0, MAPBASE*VBASE);
   FileReadArray(handle, MapHold, 0, HOLDBASE*VBASE);
   FileClose(handle);
}

//
//
//
//
//

void SaveKohonenMap()
{
   int handle = FileOpen(MapPath, FILE_BIN|FILE_WRITE|FILE_READ);
   if (handle < 1)
   {
      Print("File couldn't be opened; the last error is ", GetLastError());
      return(0);
   }
   FileWriteArray(handle, MapBuy, 0, MAPBASE*VBASE);
   FileWriteArray(handle, MapSell,0, MAPBASE*VBASE);
   FileWriteArray(handle, MapHold,0, HOLDBASE*VBASE);
}    

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ShowComments()
{ 
   if (IsTesting() && !IsVisualMode()) return;
   if (IsTesting()) return;
   
   //
   //
   //
   //
   //
   
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
  	double modifier = 1;
  	int    digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
  	//
  	//
  	//
  	//
  	//
  
   if(MarketInfo(symbol,MODE_SWAPLONG) > 0)                                string    swap="longs,";
                                                                           else      swap="shorts.";
   if(MarketInfo(symbol,MODE_SWAPLONG) < 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0) swap="your broker. ";
   
   //
   //
   //
   //
   //  
   
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   
   sComment = sComment + sp;
   sComment = sComment + "BMU Trend" + NL; 
   sComment = sComment + sp;
   sComment = sComment + "Trend Analysis" + NL; 
   sComment = sComment + "BMU Buy: " + bmu[Current] + NL; 
   sComment = sComment + "BMU Sell: " + bmu[Current+1] + NL;  
   sComment = sComment + "BMU Hold: " + bmu[Current+2] + NL; 
   sComment = sComment + sp;
   sComment = sComment + timeFilterText + NL; 
   sComment = sComment + sp;
   sComment = sComment + "Market Analysis" + NL;
   sComment = sComment + "Swap favors " + swap + NL; 
   sComment = sComment + "Swap Long      = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) + NL; 
   sComment = sComment + "Swap Short     = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2) + NL; 
   sComment = sComment + "Current Spread = " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/ modifier,2) + NL;  
   sComment = sComment + sp;
   sComment = sComment + "Have a great trading day" + NL;
   sComment = sComment + sp; 
   
   Comment(sComment);  
}